#include <opencv2/opencv.hpp>
#include "hough_transform.h"

using namespace cv;

char helper[] = 
"02_IPP_HoughTransform.exe <image>\n\
\t<image> - image name\n";

int main(int argc, char **argv)
{
    Mat srcImgOCV, srcImgIPP, dstImgOCV, dstImgIPP;
    vector<Point> points1OCV, points2OCV, points1IPP, points2IPP;
    if (argc < 2)
    {
        printf("%s", helper);
        return 1;
    }
    
    //  
    srcImgOCV = imread(argv[1]);
    if (srcImgOCV.data == 0)
    {
        printf("ERROR!!! imread(...)");
        return 1;
    }
    srcImgOCV.copyTo(srcImgIPP);

    hough_opencv(srcImgOCV, points1OCV, points2OCV); 
    hough_ipp(srcImgIPP, points1IPP, points2IPP);

    //  ,  
    drawLines(srcImgOCV, points1OCV, points2OCV);
    drawLines(srcImgIPP, points1IPP, points2IPP);
	namedWindow("OpenCV");
    imshow("OpenCV", srcImgOCV);
    namedWindow("IPP");
    imshow("IPP", srcImgIPP);
    waitKey();
    
    //  
    srcImgOCV.release();
    srcImgIPP.release();
    dstImgOCV.release();
    dstImgIPP.release();
    return 0;
}